#ifndef PARSER_HPP
#define PARSER_HPP

#include <sstream>
#include <string>
#include "node.hpp"

class Parser : public istringstream {
	private:
		enum {
			NUM, X, PLUS, MINUS, MUL, DIV, POW, 
			LPAR, RPAR, LOG, EXP, SIN, COS, ATAN, SQRT,
			DER, SEMI, BAD
		};

		Node* lft;
		Node* rgt;
		int gettok(void);
		Node *expr(void);
		Node *term(void);
		Node *factor(void);
		Node *prim(void);
		void error(string);
		int  ch;		// ultimo caracter leido
		int  tok;		// ultimo token leido
		double num; 	// ultimo numero leido

	public:
		Parser(string, Node* =NULL, Node* =NULL);
		Node *line(void);
};

#endif

